#include <stdio.h>
#include <string.h>

double         OT_float_to_double( unsigned short );
unsigned short double_to_OT_float( double );


int main(void)
{
  double a[] = { -128.0, -74.39, 0, 65.9, 126.99, 127 };
  int i;
  unsigned short val;
  double hlp;
  for ( i=0; i<6; i++)
    {
      val = double_to_OT_float( a[i] );
      printf( "a[%d] = %8.3f, val_h = %d, val_l = %d\n", i, a[i], (char) (val>>8),
	      val &0x00ff );

      hlp = OT_float_to_double( val );
      printf( "hlp = %8.4f\n", hlp);
    }
}

unsigned short double_to_OT_float( double val )
{
  /* 
   * convert double to unsigned short (f8.8 float, actually) according to the
   * OT protocol. 
   */

  short hlp;
  char val_h;
  unsigned char val_l;
  unsigned short ret;

  val *= 256.0;
  val_h = (char)(((short)(val))>>8);
  val_l = (unsigned char)(((short)(val)) & 0x00ff);
  //printf("val_l = %02x, val_l = %3d, val_h = %02x, val_h=%03d\n", val_l, val_l, val_h, val_h );
  hlp = ((short)(val_h)<<8) | (short)(val_l) ;
  memcpy( &ret, &hlp, sizeof( short ) );

  return ret;
}



double OT_float_to_double( unsigned short val )
{
  /* 
   * convert unsigned short (f8.8 float really) to double according to the 
   * OT protocol. 
   */
  short h, l;
  h = (short)((char)( val >> 8 ));
  h = h << 8;
  printf("h = %04x, val = %02x\n", h, (char)( val >> 8 ) );
  l = (short)( val & 0x00ff );

  return ( (double) ( h | l ) ) / 256.0;
}
